Page MenuHomePhabricator

[sanitizer] Place module_ctor/module_dtor in llvm.used
ClosedPublic

Authored by MaskRay on Jul 18 2021, 1:04 PM.

Details

Summary

This removes an abuse of ELF linker behaviors while keeping Mach-O/COFF linker
behaviors unchanged.

ELF: when module_ctor is in a comdat, this patch removes reliance on a linker
abuse (an SHT_INIT_ARRAY in a section group retains the whole group) by using
SHF_GNU_RETAIN. No linker behavior difference when module_ctor is not in a comdat.

Mach-O: module_ctor gets N_NO_DEAD_STRIP. No linker behavior difference
because module_ctor is already referenced by a S_MOD_INIT_FUNC_POINTERS
section (GC root).

PE/COFF: no-op. SanitizerCoverage already appends module_ctor to llvm.used.
Other sanitizers: llvm.used for local linkage is not implemented in
TargetLoweringObjectFileCOFF::emitLinkerDirectives (once implemented or
switched to a non-local linkage, COFF can use module_ctor in comdat (i.e.
generalize ELF-specific rL301586)).

There is no object file size difference.


I think module_ctor should have linkonce_odr hidden linkage/visibility.
This will

  • make COFF deduplication work
  • drop the reliance on the comdat lowering behavior on ELF (internal module_ctor should not be deduplicated, so rGc4b4253f7c63de8452eabf0105d87a17ff47748f doesn't actually conform to LangRef).

I'll investigate it in another patch.

Diff Detail

Event Timeline

MaskRay created this revision.Jul 18 2021, 1:04 PM
MaskRay requested review of this revision.Jul 18 2021, 1:04 PM
Herald added a project: Restricted Project. · View Herald TranscriptJul 18 2021, 1:04 PM
vitalybuka added inline comments.Jul 19 2021, 11:40 AM
llvm/lib/Transforms/Instrumentation/SanitizerCoverage.cpp
387

why we don't need this one?

MaskRay added inline comments.Jul 19 2021, 12:18 PM
llvm/lib/Transforms/Instrumentation/SanitizerCoverage.cpp
387

llvm::createSanitizerCtor has appendToUsed, so this is now redundant.

MaskRay marked an inline comment as done.Jul 20 2021, 11:39 PM
vitalybuka accepted this revision.Jul 21 2021, 1:49 PM
This revision is now accepted and ready to land.Jul 21 2021, 1:49 PM
This revision was landed with ongoing or failed builds.Jul 21 2021, 2:03 PM
This revision was automatically updated to reflect the committed changes.